iCAx开思工具箱

标题: 关于UG二次开发 [打印本页]

作者: liyuzhou03    时间: 2009-5-4 18:47
标题: 关于UG二次开发
在apply下添加代码,实现某物体的旋转。用到uf4945。
请问该如何实现?
刚入手不久,所以不太熟悉。

细说明,比如我建立一条直线,然后点击“应用”,让该直线绕X轴旋转45°。
int SIMULATION_apply_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
          if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

//Enter your callback code here

           UF_terminate ();
          return (UF_UI_CB_CONTINUE_DIALOG);
}
作者: daojianrm    时间: 2009-5-4 20:50
可先查阅一下帮助文档中对uf4945的说明
作者: liyuzhou03    时间: 2009-5-4 21:09
void uf5945
(

double origin [ 3 ]
double direction [ 3 ]
double * degrees_rotation
double matrix [ 16 ]
int * status

)
这是文档中对uf4945的说明。
但是不知道怎么用。
作者: daojianrm    时间: 2009-5-5 19:18
通过原点,方向和旋转的角度确定一个矩阵,这个矩阵用于UF5947中的输入旋转矩阵参数
作者: liyuzhou03    时间: 2009-5-5 20:37
daojianrm 发表于 2009-5-5 19:18
通过原点,方向和旋转的角度确定一个矩阵,这个矩阵用于UF5947中的输入旋转矩阵参数


可以给一个简单例子吗?
作者: daojianrm    时间: 2009-5-5 21:16
UF_FEATURE_SIGN sign = UF_NULLSIGN;
        double block_orig[3] = {0,0,0};
        char *block_len[3]= {"20","20","20"};
        tag_t group1, group2;
        int err;

        UF_CALL(UF_PART_new("d:\\block.prt",1,&group1));

        err=UF_MODL_create_block1(sign, block_orig, block_len, &group1);

        UF_MODL_ask_feat_body(group1, &group2);

double origin[3]={0,0,0};
        double direction[3]={0,0,1};
        double degrees_rotation=45;
        double matrix_rotation[16];
        int status_totation;
        FTN(uf5945)(origin,direction,&degrees_rotation,matrix_rotation,&status_totation);

        int n_object_r=1;
        int copy_or_move_r=1;
        int dest_layer_r=0;
        int trace_curve_r=2;
        tag_t copies_r;
        tag_t trace_curve_group_r;
        int status_r;
        FTN(uf5947) (matrix_rotation,&group2,&n_object_r,&copy_or_move_r,
             &dest_layer_r,&trace_curve_r,&copies_r,&trace_curve_group_r,&status_r);
作者: daojianrm    时间: 2009-5-5 21:17
创建并旋转一个长方体
作者: liyuzhou03    时间: 2009-5-6 21:43
daojianrm 发表于 2009-5-5 21:17
创建并旋转一个长方体


万分感谢!!!!!




欢迎光临 iCAx开思工具箱 (https://t.icax.org/) Powered by Discuz! X3.3